diff --git a/src/odbc/unittests/cursor3.c b/src/odbc/unittests/cursor3.c
index 5a6849f..abe3513 100644
--- a/src/odbc/unittests/cursor3.c
+++ b/src/odbc/unittests/cursor3.c
@@ -1,62 +1,15 @@
 /* Tests 2 active statements */
 #include "common.h"
 
-static char software_version[] = "$Id: cursor3.c,v 1.6 2008/02/06 08:28:10 freddy77 Exp $";
+static char software_version[] = "$Id: cursor3.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-#define CHECK_RCODE(t,h,m) \
-   if ( rcode != SQL_NO_DATA \
-     && rcode != SQL_SUCCESS \
-     && rcode != SQL_SUCCESS_WITH_INFO  \
-     && rcode != SQL_NEED_DATA ) { \
-      fprintf(stderr,"Error %d at: %s\n",rcode,m); \
-      getErrorInfo(t,h); \
-      exit(1); \
-   }
-
-static void
-getErrorInfo(SQLSMALLINT sqlhdltype, SQLHANDLE sqlhandle)
-{
-	SQLRETURN rcode = 0;
-	SQLCHAR sqlstate[SQL_SQLSTATE_SIZE + 1];
-	SQLINTEGER naterror = 0;
-	SQLCHAR msgtext[SQL_MAX_MESSAGE_LENGTH + 1];
-	SQLSMALLINT msgtextl = 0;
-
-	rcode = SQLGetDiagRec((SQLSMALLINT) sqlhdltype,
-			      (SQLHANDLE) sqlhandle,
-			      (SQLSMALLINT) 1,
-			      (SQLCHAR *) sqlstate,
-			      (SQLINTEGER *) & naterror,
-			      (SQLCHAR *) msgtext, (SQLSMALLINT) sizeof(msgtext), (SQLSMALLINT *) & msgtextl);
-	fprintf(stderr, "Diagnostic info:\n");
-	fprintf(stderr, "  SQL State: %s\n", (char *) sqlstate);
-	fprintf(stderr, "  SQL code : %d\n", (int) naterror);
-	fprintf(stderr, "  Message  : %s\n", (char *) msgtext);
-}
-
-static void
-exec_direct(int check, const char *stmt)
-{
-	SQLRETURN rcode;
-	SQLHSTMT stmth = 0;
-
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, (SQLHANDLE) Connection, (SQLHANDLE *) & stmth);
-	CHECK_RCODE(SQL_HANDLE_STMT, stmth, "SQLAllocHandle");
-	rcode = SQLExecDirect(stmth, (SQLCHAR *) stmt, SQL_NTS);
-	if (check) {
-		CHECK_RCODE(SQL_HANDLE_STMT, stmth, "SQLExecDirect");
-	}
-	rcode = SQLFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) stmth);
-	CHECK_RCODE(SQL_HANDLE_STMT, stmth, "SQLFreeHandle");
-}
-
 int
 main(int argc, char **argv)
 {
-	SQLRETURN rcode;
-	SQLHSTMT m_hstmt1;
-	SQLHSTMT m_hstmt2;
+	SQLHSTMT stmt1 = SQL_NULL_HSTMT;
+	SQLHSTMT stmt2 = SQL_NULL_HSTMT;
+	SQLHSTMT old_Statement;
 	char buff[64];
 	SQLLEN ind;
 
@@ -65,88 +18,70 @@ main(int argc, char **argv)
 
 	CheckCursor();
 
-	exec_direct(1, "CREATE TABLE #t1 ( k INT, c VARCHAR(20))");
-	exec_direct(1, "INSERT INTO #t1 VALUES (1, 'aaa')");
-	exec_direct(1, "INSERT INTO #t1 VALUES (2, 'bbbbb')");
-	exec_direct(1, "INSERT INTO #t1 VALUES (3, 'ccccccccc')");
-	exec_direct(1, "INSERT INTO #t1 VALUES (4, 'dd')");
-
-	m_hstmt1 = NULL;
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, Connection, &m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_DBC, Connection, "SQLAllocHandle 1");
-
-	m_hstmt2 = NULL;
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, Connection, &m_hstmt2);
-	CHECK_RCODE(SQL_HANDLE_DBC, Connection, "SQLAllocHandle 2");
+	Command(Statement, "CREATE TABLE #t1 ( k INT, c VARCHAR(20))");
+	Command(Statement, "INSERT INTO #t1 VALUES (1, 'aaa')");
+	Command(Statement, "INSERT INTO #t1 VALUES (2, 'bbbbb')");
+	Command(Statement, "INSERT INTO #t1 VALUES (3, 'ccccccccc')");
+	Command(Statement, "INSERT INTO #t1 VALUES (4, 'dd')");
 
-/*
-	rcode = SQLSetStmtAttr(m_hstmt1, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER);
-	CHECK_RCODE(SQL_HANDLE_STMT,m_hstmt1,"Set attribute SQL_ATTR_CURSOR_SCROLLABLE 1");
-*/
+	old_Statement = Statement;
 
-	rcode = SQLSetStmtAttr(m_hstmt1, SQL_ATTR_CURSOR_SENSITIVITY, (SQLPOINTER) SQL_SENSITIVE, SQL_IS_UINTEGER);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "Set attribute SQL_ATTR_CURSOR_SENSITIVITY 1");
+	CHKAllocHandle(SQL_HANDLE_STMT, Connection, &stmt1, "S");
+	CHKAllocHandle(SQL_HANDLE_STMT, Connection, &stmt2, "S");
 
-/*
-	rcode = SQLSetStmtAttr(m_hstmt2, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER);
-	CHECK_RCODE(SQL_HANDLE_STMT,m_hstmt2,"Set attribute SQL_ATTR_CURSOR_SCROLLABLE 2");
-*/
 
-	rcode = SQLSetStmtAttr(m_hstmt2, SQL_ATTR_CURSOR_SENSITIVITY, (SQLPOINTER) SQL_SENSITIVE, SQL_IS_UINTEGER);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt2, "Set attribute SQL_ATTR_CURSOR_SENSITIVITY 2");
+	Statement = stmt1;
+/*	CHKSetStmtAttr(SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER, "S"); */
+	CHKSetStmtAttr(SQL_ATTR_CURSOR_SENSITIVITY, (SQLPOINTER) SQL_SENSITIVE, SQL_IS_UINTEGER, "S");
+/*	CHKSetStmtAttr(SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_LOCK, SQL_IS_UINTEGER, "S"); */
 
-/*
-	rcode = SQLSetStmtAttr(m_hstmt1, SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_LOCK, SQL_IS_UINTEGER);
-	CHECK_RCODE(SQL_HANDLE_STMT,m_hstmt1,"Set attribute SQL_ATTR_CONCURRENCY 1");
 
-	rcode = SQLSetStmtAttr(m_hstmt2, SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_LOCK, SQL_IS_UINTEGER);
-	CHECK_RCODE(SQL_HANDLE_STMT,m_hstmt2,"Set attribute SQL_ATTR_CONCURRENCY 2");
-*/
+	Statement = stmt2;
+/*	CHKSetStmtAttr(SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER, "S"); */
+	CHKSetStmtAttr(SQL_ATTR_CURSOR_SENSITIVITY, (SQLPOINTER) SQL_SENSITIVE, SQL_IS_UINTEGER, "S");
+/*	CHKSetStmtAttr(SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_LOCK, SQL_IS_UINTEGER, "S"); */
 
-	rcode = SQLSetCursorName(m_hstmt1, (SQLCHAR *) "c1", SQL_NTS);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SetCursorName c1");
+	Statement = stmt1;
+	CHKSetCursorName((SQLCHAR *) "c1", SQL_NTS, "S");
 
-	rcode = SQLSetCursorName(m_hstmt2, (SQLCHAR *) "c2", SQL_NTS);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt2, "SetCursorName c2");
+	Statement = stmt2;
+	CHKSetCursorName((SQLCHAR *) "c2", SQL_NTS, "S");
 
-	rcode = SQLPrepare(m_hstmt1, (SQLCHAR *) "SELECT * FROM #t1", SQL_NTS);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "Prepare 1");
+	Statement = stmt1;
+	CHKPrepare((SQLCHAR *) "SELECT * FROM #t1", SQL_NTS, "S");
 
-	rcode = SQLPrepare(m_hstmt2, (SQLCHAR *) "SELECT * FROM #t1", SQL_NTS);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt2, "Prepare 2");
+	Statement = stmt2;
+	CHKPrepare((SQLCHAR *) "SELECT * FROM #t1", SQL_NTS, "S");
 
-	rcode = SQLExecute(m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLExecute 1");
+	Statement = stmt1;
+	CHKExecute("S");
 
-	rcode = SQLExecute(m_hstmt2);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt2, "SQLExecute 2");
+	Statement = stmt2;
+	CHKExecute("S");
 
-	rcode = SQLFetch(m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLFetch 1");
+	Statement = stmt1;
+	CHKFetch("S");
 
-	rcode = SQLGetData(m_hstmt1, 2, SQL_C_CHAR, (SQLPOINTER) buff, sizeof(buff), &ind);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLGetData 1");
+	CHKGetData(2, SQL_C_CHAR, (SQLPOINTER) buff, sizeof(buff), &ind, "S");
 	printf(">> Fetch from 1: [%s]\n", buff);
 
-	rcode = SQLFetch(m_hstmt2);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt2, "SQLFetch 2");
+	Statement = stmt2;
+	CHKFetch("S");
 
-	rcode = SQLGetData(m_hstmt2, 2, SQL_C_CHAR, (SQLPOINTER) buff, sizeof(buff), &ind);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt2, "SQLGetData 2");
+	CHKGetData(2, SQL_C_CHAR, (SQLPOINTER) buff, sizeof(buff), &ind, "S");
 	printf(">> Fetch from 2: [%s]\n", buff);
 
-	rcode = SQLCloseCursor(m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLCloseCursor 1");
-
-	rcode = SQLCloseCursor(m_hstmt2);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt2, "SQLCloseCursor 2");
-
-	rcode = SQLFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLFreeHandle 1");
+	Statement = stmt1;
+	CHKCloseCursor("SI");
+	Statement = stmt2;
+	CHKCloseCursor("SI");
 
-	rcode = SQLFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) m_hstmt2);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt2, "SQLFreeHandle 2");
+	Statement = stmt1;
+	CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) stmt1, "S");
+	Statement = stmt2;
+	CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) stmt2, "S");
 
+	Statement = old_Statement;
 	Disconnect();
 
 	return 0;
diff --git a/src/odbc/unittests/cursor4.c b/src/odbc/unittests/cursor4.c
index c1ac6cd..9f228b5 100755
--- a/src/odbc/unittests/cursor4.c
+++ b/src/odbc/unittests/cursor4.c
@@ -5,61 +5,24 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: cursor4.c,v 1.6 2008/02/06 08:28:10 freddy77 Exp $";
+static char software_version[] = "$Id: cursor4.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-#define CHECK_RCODE(t,h,m) \
-   if ( rcode != SQL_NO_DATA \
-     && rcode != SQL_SUCCESS \
-     && rcode != SQL_SUCCESS_WITH_INFO  \
-     && rcode != SQL_NEED_DATA ) { \
-      fprintf(stderr,"Error %d at: %s\n",rcode,m); \
-      getErrorInfo(t,h); \
-      exit(1); \
-   }
-
 static void
-getErrorInfo(SQLSMALLINT sqlhdltype, SQLHANDLE sqlhandle)
+exec_direct(const char *stmt)
 {
-	SQLRETURN rcode = 0;
-	SQLCHAR sqlstate[SQL_SQLSTATE_SIZE + 1];
-	SQLINTEGER naterror = 0;
-	SQLCHAR msgtext[SQL_MAX_MESSAGE_LENGTH + 1];
-	SQLSMALLINT msgtextl = 0;
-
-	rcode = SQLGetDiagRec((SQLSMALLINT) sqlhdltype,
-			      (SQLHANDLE) sqlhandle,
-			      (SQLSMALLINT) 1,
-			      (SQLCHAR *) sqlstate,
-			      (SQLINTEGER *) & naterror,
-			      (SQLCHAR *) msgtext, (SQLSMALLINT) sizeof(msgtext), (SQLSMALLINT *) & msgtextl);
-	fprintf(stderr, "Diagnostic info:\n");
-	fprintf(stderr, "  SQL State: %s\n", (char *) sqlstate);
-	fprintf(stderr, "  SQL code : %d\n", (int) naterror);
-	fprintf(stderr, "  Message  : %s\n", (char *) msgtext);
-}
+	SQLHSTMT old_Statement = Statement;
 
-static void
-exec_direct(int check, const char *stmt)
-{
-	SQLRETURN rcode;
-	SQLHSTMT stmth = 0;
-
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, (SQLHANDLE) Connection, (SQLHANDLE *) & stmth);
-	CHECK_RCODE(SQL_HANDLE_STMT, stmth, "SQLAllocHandle");
-	rcode = SQLExecDirect(stmth, (SQLCHAR *) stmt, SQL_NTS);
-	if (check) {
-		CHECK_RCODE(SQL_HANDLE_STMT, stmth, "SQLExecDirect");
-	}
-	rcode = SQLFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) stmth);
-	CHECK_RCODE(SQL_HANDLE_STMT, stmth, "SQLFreeHandle");
+	Statement = SQL_NULL_HSTMT;
+	CHKAllocHandle(SQL_HANDLE_STMT, (SQLHANDLE) Connection, (SQLHANDLE *) & Statement, "S");
+	Command(Statement, stmt);
+	CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) Statement, "S");
+	Statement = old_Statement;
 }
 
 int
 main(int argc, char **argv)
 {
-	SQLRETURN rcode;
-	SQLHSTMT m_hstmt1;
 	char buff[64];
 	SQLLEN ind;
 
@@ -68,50 +31,39 @@ main(int argc, char **argv)
 
 	CheckCursor();
 
-	exec_direct(1, "CREATE TABLE #t1 ( k INT, c VARCHAR(20))");
-	exec_direct(1, "INSERT INTO #t1 VALUES (1, 'aaa')");
+	exec_direct("CREATE TABLE #t1 ( k INT, c VARCHAR(20))");
+	exec_direct("INSERT INTO #t1 VALUES (1, 'aaa')");
 
-	m_hstmt1 = NULL;
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, Connection, &m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_DBC, Connection, "SQLAllocHandle 1");
+	ResetStatement();
 
-	rcode = SQLSetStmtAttr(m_hstmt1, SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_LOCK, SQL_IS_UINTEGER);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "Set attribute SQL_ATTR_CONCURRENCY");
+	CHKSetStmtAttr(SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_LOCK, SQL_IS_UINTEGER, "S");
 
-	rcode = SQLSetCursorName(m_hstmt1, (SQLCHAR *) "c112", SQL_NTS);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SetCursorName c112");
+	CHKSetCursorName((SQLCHAR *) "c112", SQL_NTS, "S");
 
-	rcode = SQLPrepare(m_hstmt1, (SQLCHAR *) "SELECT * FROM #t1 FOR UPDATE", SQL_NTS);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "Prepare 2");
+	CHKPrepare((SQLCHAR *) "SELECT * FROM #t1 FOR UPDATE", SQL_NTS, "S");
 
-	exec_direct(1, "BEGIN TRANSACTION");
+	exec_direct("BEGIN TRANSACTION");
 
-	rcode = SQLExecute(m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLExecute 2");
+	CHKExecute("S");
 
-	rcode = SQLFetch(m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLFetch 1");
+	CHKFetch("S");
 
-	exec_direct(1, "UPDATE #t1 SET c = 'xxx' WHERE CURRENT OF c112");
+	exec_direct("UPDATE #t1 SET c = 'xxx' WHERE CURRENT OF c112");
 
-	rcode = SQLCloseCursor(m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLCloseCursor 2");
+	CHKCloseCursor("SI");
 
-	exec_direct(1, "COMMIT TRANSACTION");
+	exec_direct("COMMIT TRANSACTION");
 
-	rcode = SQLExecDirect(m_hstmt1, (SQLCHAR *) "SELECT c FROM #t1 WHERE k = 1", SQL_NTS);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLExecDirect 2");
+	CHKExecDirect((SQLCHAR *) "SELECT c FROM #t1 WHERE k = 1", SQL_NTS, "S");
 
-	rcode = SQLFetch(m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLFetch 2");
+	CHKFetch("S");
 
-	rcode = SQLGetData(m_hstmt1, 1, SQL_C_CHAR, buff, sizeof(buff), &ind);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLGetData");
+	CHKGetData(1, SQL_C_CHAR, buff, sizeof(buff), &ind, "S");
 
 	printf(">> New value after update = [%s] (should be [xxx]) \n", buff);
 
-	rcode = SQLFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLFreeHandle 1");
+	CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) Statement, "S");
+	Statement = SQL_NULL_HSTMT;
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/cursor5.c b/src/odbc/unittests/cursor5.c
index 4797287..ea8d459 100755
--- a/src/odbc/unittests/cursor5.c
+++ b/src/odbc/unittests/cursor5.c
@@ -1,18 +1,8 @@
 #include "common.h"
 
-static char software_version[] = "$Id: cursor5.c,v 1.6 2008/10/31 14:35:23 freddy77 Exp $";
+static char software_version[] = "$Id: cursor5.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-#define CHECK_RCODE(t,h,m) \
-   if ( rcode != SQL_NO_DATA \
-     && rcode != SQL_SUCCESS \
-     && rcode != SQL_SUCCESS_WITH_INFO  \
-     && rcode != SQL_NEED_DATA ) { \
-      fprintf(stderr,"Error %d at: %s\n",rcode,m); \
-      getErrorInfo(t,h); \
-      exit(1); \
-   }
-
 static SQLINTEGER v_int_3;
 static SQLLEN v_ind_3_1;
 
@@ -20,33 +10,13 @@ static char v_char_3[21];
 static SQLLEN v_ind_3_2;
 
 static void
-getErrorInfo(SQLSMALLINT sqlhdltype, SQLHANDLE sqlhandle)
-{
-	SQLRETURN rcode = 0;
-	SQLCHAR sqlstate[SQL_SQLSTATE_SIZE + 1];
-	SQLINTEGER naterror = 0;
-	SQLCHAR msgtext[SQL_MAX_MESSAGE_LENGTH + 1];
-	SQLSMALLINT msgtextl = 0;
-
-	rcode = SQLGetDiagRec((SQLSMALLINT) sqlhdltype,
-			      (SQLHANDLE) sqlhandle,
-			      (SQLSMALLINT) 1,
-			      (SQLCHAR *) sqlstate,
-			      (SQLINTEGER *) & naterror,
-			      (SQLCHAR *) msgtext, (SQLSMALLINT) sizeof(msgtext), (SQLSMALLINT *) & msgtextl);
-	fprintf(stderr, "Diagnostic info:\n");
-	fprintf(stderr, "  SQL State: %s\n", (char *) sqlstate);
-	fprintf(stderr, "  SQL code : %d\n", (int) naterror);
-	fprintf(stderr, "  Message  : %s\n", (char *) msgtext);
-}
-
-static void
 doFetch(int dir, int pos)
 {
-	SQLRETURN rcode = SQLFetchScroll(Statement, dir, pos);
+	SQLRETURN RetCode;
+
+	CHKFetchScroll(dir, pos, "SINo");
 
-	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLFetchScroll");
-	if (rcode != SQL_NO_DATA)
+	if (RetCode != SQL_NO_DATA)
 		printf(">> fetch %2d %10d : %d [%s]\n", dir, pos, v_ind_3_1 ? (int) v_int_3 : -1, v_ind_3_2 ? v_char_3 : "null");
 	else
 		printf(">> fetch %2d %10d : no data found\n", dir, pos);
@@ -55,13 +25,11 @@ doFetch(int dir, int pos)
 int
 main(int argc, char **argv)
 {
-	SQLRETURN rcode;
-
 	use_odbc_version3 = 1;
 	Connect();
 	CheckCursor();
 
-	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, (SQLPOINTER) SQL_AUTOCOMMIT_ON, SQL_IS_UINTEGER));
+	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, (SQLPOINTER) SQL_AUTOCOMMIT_ON, SQL_IS_UINTEGER, "S");
 
 	Command(Statement, "create table #mytab1 (k int, c char(30))");
 	Command(Statement, "insert into #mytab1 values (1,'aaa')");
@@ -69,17 +37,15 @@ main(int argc, char **argv)
 	Command(Statement, "insert into #mytab1 values (3,'ccc')");
 
 	ResetStatement();
-/*	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_STATIC, 0));	*/
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_SCROLLABLE, SQL_IS_UINTEGER));
+/*	CHKSetStmtAttr(SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_STATIC, 0, "S");	*/
+	CHKSetStmtAttr(SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_SCROLLABLE, SQL_IS_UINTEGER, "S");
 
-	rcode = SQLPrepare(Statement, (SQLCHAR *) "select k, c from #mytab1 order by k", SQL_NTS);
-	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLPrepare 3");
+	CHKPrepare((SQLCHAR *) "select k, c from #mytab1 order by k", SQL_NTS, "SI");
 
-	CHK(SQLBindCol, (Statement, 1, SQL_C_LONG, &v_int_3, 0, &v_ind_3_1));
-	CHK(SQLBindCol, (Statement, 2, SQL_C_CHAR, v_char_3, sizeof(v_char_3), &v_ind_3_2));
+	CHKBindCol(1, SQL_C_LONG, &v_int_3, 0, &v_ind_3_1, "S");
+	CHKBindCol(2, SQL_C_CHAR, v_char_3, sizeof(v_char_3), &v_ind_3_2, "S");
 
-	rcode = SQLExecute(Statement);
-	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLExecute StmtH 3");
+	CHKExecute("SI");
 
 	doFetch(SQL_FETCH_LAST, 0);
 	doFetch(SQL_FETCH_PRIOR, 0);
@@ -97,8 +63,7 @@ main(int argc, char **argv)
 	doFetch(SQL_FETCH_RELATIVE, -2);
 	doFetch(SQL_FETCH_RELATIVE, 5);
 
-	rcode = SQLCloseCursor(Statement);
-	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLCloseCursor StmtH 2");
+	CHKCloseCursor("SI");
 
 	Disconnect();
 	return 0;
diff --git a/src/odbc/unittests/cursor6.c b/src/odbc/unittests/cursor6.c
index 3553852..6f3e431 100755
--- a/src/odbc/unittests/cursor6.c
+++ b/src/odbc/unittests/cursor6.c
@@ -2,7 +2,7 @@
 
 /* Test SQLFetchScroll with no binded columns */
 
-static char software_version[] = "$Id: cursor6.c,v 1.3 2008/07/16 07:47:02 freddy77 Exp $";
+static char software_version[] = "$Id: cursor6.c,v 1.4 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int bind_all = 0;
@@ -25,18 +25,18 @@ static void Test(void)
 
 	/* this should not fail or return warnings */
 	if (use_cursors) {
-		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CONCURRENCY, int2ptr(SQL_CONCUR_READ_ONLY), 0));
-		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_TYPE, int2ptr(SQL_CURSOR_STATIC), 0));
+		CHKSetStmtAttr(SQL_ATTR_CONCURRENCY, int2ptr(SQL_CONCUR_READ_ONLY), 0, "S");
+		CHKSetStmtAttr(SQL_ATTR_CURSOR_TYPE, int2ptr(SQL_CURSOR_STATIC), 0, "S");
 	}
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "SELECT c, i FROM #cursor6_test", SQL_NTS));
-	CHK(SQLExecute, (Statement));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_BIND_TYPE, int2ptr(sizeof(data[0])), 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_ARRAY_SIZE, int2ptr(ROWS), 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_STATUS_PTR, statuses, 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROWS_FETCHED_PTR, &num_row, 0));
+	CHKPrepare((SQLCHAR *) "SELECT c, i FROM #cursor6_test", SQL_NTS, "S");
+	CHKExecute("S");
+	CHKSetStmtAttr(SQL_ATTR_ROW_BIND_TYPE, int2ptr(sizeof(data[0])), 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROW_ARRAY_SIZE, int2ptr(ROWS), 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROW_STATUS_PTR, statuses, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROWS_FETCHED_PTR, &num_row, 0, "S");
 	if (bind_all)
-		CHK(SQLBindCol, (Statement, 1, SQL_C_CHAR, &data[0].c, sizeof(data[0].c), &data[0].ind_c));
-	CHK(SQLBindCol, (Statement, 2, SQL_C_LONG, &data[0].i, sizeof(data[0].i), &data[0].ind_i));
+		CHKBindCol(1, SQL_C_CHAR, &data[0].c, sizeof(data[0].c), &data[0].ind_c, "S");
+	CHKBindCol(2, SQL_C_LONG, &data[0].i, sizeof(data[0].i), &data[0].ind_i, "S");
 
 #define FILL(s, n) do { \
 	int _n; for (_n = 0; _n < sizeof(s)/sizeof(s[0]); ++_n) s[_n] = n; \
@@ -46,9 +46,9 @@ static void Test(void)
 	data[0].i = 0xdeadbeef;
 	data[1].i = 0xdeadbeef;
 	if (normal_fetch)
-		CHK(SQLFetch, (Statement));
+		CHKFetch("S");
 	else
-		CHK(SQLFetchScroll, (Statement, SQL_FETCH_NEXT, 0));
+		CHKFetchScroll(SQL_FETCH_NEXT, 0, "S");
 
 	/* now check row numbers */
 	printf("num_row %d statuses[0] %d statuses[1] %d odbc3 %d\n", (int) num_row,
@@ -69,9 +69,9 @@ static void Test(void)
 	FILL(statuses, 8765);
 	num_row = -3;
 	if (normal_fetch)
-		CHK(SQLFetch, (Statement));
+		CHKFetch("S");
 	else
-		CHK(SQLFetchScroll, (Statement, SQL_FETCH_NEXT, 0));
+		CHKFetchScroll(SQL_FETCH_NEXT, 0, "S");
 }
 
 static void Init(void)
diff --git a/src/odbc/unittests/cursor7.c b/src/odbc/unittests/cursor7.c
index acd58c9..02cac03 100644
--- a/src/odbc/unittests/cursor7.c
+++ b/src/odbc/unittests/cursor7.c
@@ -2,7 +2,7 @@
 
 /* Test SQLFetchScroll with a non-unitary rowset, using bottom-up direction */
 
-static char software_version[] = "$Id: cursor7.c,v 1.5 2008/07/16 07:47:02 freddy77 Exp $";
+static char software_version[] = "$Id: cursor7.c,v 1.6 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -19,27 +19,27 @@ Test(void)
 	SQLULEN num_row;
 
 	int i;
-	SQLRETURN ErrCode;
+	SQLRETURN RetCode;
 
 	ResetStatement();
 
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CONCURRENCY, int2ptr(SQL_CONCUR_READ_ONLY), 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_TYPE, int2ptr(SQL_CURSOR_STATIC), 0));
+	CHKSetStmtAttr(SQL_ATTR_CONCURRENCY, int2ptr(SQL_CONCUR_READ_ONLY), 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_CURSOR_TYPE, int2ptr(SQL_CURSOR_STATIC), 0, "S");
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "SELECT c, i FROM #cursor7_test", SQL_NTS));
-	CHK(SQLExecute, (Statement));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_BIND_TYPE, int2ptr(sizeof(data[0])), 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_ARRAY_SIZE, int2ptr(ROWS), 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_STATUS_PTR, statuses, 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROWS_FETCHED_PTR, &num_row, 0));
+	CHKPrepare((SQLCHAR *) "SELECT c, i FROM #cursor7_test", SQL_NTS, "S");
+	CHKExecute("S");
+	CHKSetStmtAttr(SQL_ATTR_ROW_BIND_TYPE, int2ptr(sizeof(data[0])), 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROW_ARRAY_SIZE, int2ptr(ROWS), 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROW_STATUS_PTR, statuses, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROWS_FETCHED_PTR, &num_row, 0, "S");
 
-	CHK(SQLBindCol, (Statement, 1, SQL_C_CHAR, &data[0].c, sizeof(data[0].c), &data[0].ind_c));
-	CHK(SQLBindCol, (Statement, 2, SQL_C_LONG, &data[0].i, sizeof(data[0].i), &data[0].ind_i));
+	CHKBindCol(1, SQL_C_CHAR, &data[0].c, sizeof(data[0].c), &data[0].ind_c, "S");
+	CHKBindCol(2, SQL_C_LONG, &data[0].i, sizeof(data[0].i), &data[0].ind_i, "S");
 
 	/* Read records from last to first */
 	printf("\n\nReading records from last to first:\n");
-	ErrCode = SQLFetchScroll(Statement, SQL_FETCH_LAST, -ROWS);
-	while ((ErrCode == SQL_SUCCESS) || (ErrCode == SQL_SUCCESS_WITH_INFO)) {
+	CHKFetchScroll(SQL_FETCH_LAST, -ROWS, "SINo");
+	while (RetCode != SQL_NO_DATA) {
 		SQLULEN RowNumber;
 
 		/* Print this set of rows */
@@ -49,16 +49,16 @@ Test(void)
 		}
 		printf("\n");
 
-		CHK(SQLGetStmtAttr, (Statement, SQL_ROW_NUMBER, (SQLPOINTER)(&RowNumber), sizeof(RowNumber), NULL));
+		CHKGetStmtAttr(SQL_ROW_NUMBER, (SQLPOINTER)(&RowNumber), sizeof(RowNumber), NULL, "S");
 		printf("---> We are in record No: %u\n", (unsigned int) RowNumber);
 
 		/* Read next rowset */
 		if ( (RowNumber>1) && (RowNumber<ROWS) ) {
-			ErrCode=SQLFetchScroll(Statement, SQL_FETCH_RELATIVE, 1-RowNumber); 
+			CHKFetchScroll(SQL_FETCH_RELATIVE, 1-RowNumber, "SINo"); 
 			for (i=RowNumber-1; i<ROWS; ++i)
 				statuses[i] = SQL_ROW_NOROW;
 		} else {
-			ErrCode=SQLFetchScroll(Statement, SQL_FETCH_RELATIVE, -ROWS);
+			CHKFetchScroll(SQL_FETCH_RELATIVE, -ROWS, "SINo");
 		}
 	}
 }
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index 8915107..557453b 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -13,7 +13,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: data.c,v 1.24 2008/10/29 09:33:50 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.25 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
@@ -37,15 +37,9 @@ Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, con
 		sprintf(sbuf, "SELECT CONVERT(%s, %s) COLLATE Latin1_General_CI_AS AS data", type, value_to_convert);
 	Command(Statement, sbuf);
 	SQLBindCol(Statement, 1, out_c_type, out_buf, sizeof(out_buf), &out_len);
-	CHK(SQLFetch, (Statement));
-	if (SQLFetch(Statement) != SQL_NO_DATA) {
-		fprintf(stderr, "Row not expected\n");
-		exit(1);
-	}
-	if (SQLMoreResults(Statement) != SQL_NO_DATA) {
-		fprintf(stderr, "Recordset not expected\n");
-		exit(1);
-	}
+	CHKFetch("S");
+	CHKFetch("No");
+	CHKMoreResults("No");
 
 	/* test results */
 	sbuf[0] = 0;
diff --git a/src/odbc/unittests/date.c b/src/odbc/unittests/date.c
index a37360f..1b1075c 100644
--- a/src/odbc/unittests/date.c
+++ b/src/odbc/unittests/date.c
@@ -1,14 +1,12 @@
 #include "common.h"
 
 
-static char software_version[] = "$Id: date.c,v 1.10 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: date.c,v 1.11 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
 DoTest(int n)
 {
-	int res;
-
 	SQLCHAR output[256];
 
 	SQLSMALLINT colType;
@@ -20,18 +18,15 @@ DoTest(int n)
 
 	Command(Statement, "select convert(datetime, '2002-12-27 18:43:21')");
 
-	res = SQLFetch(Statement);
-	if (res != SQL_SUCCESS && res != SQL_SUCCESS_WITH_INFO)
-		ODBC_REPORT_ERROR("Unable to fetch row");
-
-	CHK(SQLDescribeCol, (Statement, 1, output, sizeof(output), NULL, &colType, &colSize, &colScale, &colNullable));
+	CHKFetch("SI");
+	CHKDescribeCol(1, output, sizeof(output), NULL, &colType, &colSize, &colScale, &colNullable, "S");
 
 	if (n == 0) {
 		memset(&ts, 0, sizeof(ts));
-		CHK(SQLGetData, (Statement, 1, SQL_C_TIMESTAMP, &ts, sizeof(ts), &dataSize));
+		CHKGetData(1, SQL_C_TIMESTAMP, &ts, sizeof(ts), &dataSize, "S");
 		sprintf((char *) output, "%04d-%02d-%02d %02d:%02d:%02d.000", ts.year, ts.month, ts.day, ts.hour, ts.minute, ts.second);
 	} else {
-		CHK(SQLGetData, (Statement, 1, SQL_C_CHAR, output, sizeof(output), &dataSize));
+		CHKGetData(1, SQL_C_CHAR, output, sizeof(output), &dataSize, "S");
 	}
 
 	printf("Date returned: %s\n", output);
@@ -40,13 +35,8 @@ DoTest(int n)
 		exit(1);
 	}
 
-	res = SQLFetch(Statement);
-	if (res != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Unable to fetch row");
-
-	res = SQLCloseCursor(Statement);
-	if (!SQL_SUCCEEDED(res))
-		ODBC_REPORT_ERROR("Unable to close cursor");
+	CHKFetch("No");
+	CHKCloseCursor("SI");
 }
 
 int
diff --git a/src/odbc/unittests/describecol.c b/src/odbc/unittests/describecol.c
index 3739957..234e45a 100644
--- a/src/odbc/unittests/describecol.c
+++ b/src/odbc/unittests/describecol.c
@@ -6,7 +6,7 @@
  * test what say SQLDescribeCol about precision using some type
  */
 
-static char software_version[] = "$Id: describecol.c,v 1.14 2008/01/20 14:23:59 freddy77 Exp $";
+static char software_version[] = "$Id: describecol.c,v 1.15 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int g_result = 0;
@@ -268,8 +268,7 @@ main(int argc, char *argv[])
 				continue;
 			}
 
-			if (!SQL_SUCCEEDED(SQLFetch(Statement)))
-				ODBC_REPORT_ERROR("Unable to fetch row");
+			CHKFetch("SI");
 			SQLBindCol(Statement, 1, SQL_C_SLONG, &i, sizeof(i), &len);
 			get_attr_p = get_attr_ird;
 		}
diff --git a/src/odbc/unittests/error.c b/src/odbc/unittests/error.c
index d8cffb2..1475b6b 100644
--- a/src/odbc/unittests/error.c
+++ b/src/odbc/unittests/error.c
@@ -2,7 +2,7 @@
 
 /* some tests on error reporting */
 
-static char software_version[] = "$Id: error.c,v 1.4 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: error.c,v 1.5 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static SQLCHAR output[256];
@@ -11,10 +11,7 @@ static void ReadError(void);
 static void
 ReadError(void)
 {
-	if (!SQL_SUCCEEDED(SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, NULL, NULL, output, sizeof(output), NULL))) {
-		printf("SQLGetDiagRec should not fail\n");
-		exit(1);
-	}
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, NULL, NULL, output, sizeof(output), NULL, "SI");
 	printf("Message: %s\n", output);
 }
 
@@ -45,10 +42,9 @@ main(int argc, char *argv[])
 
 		/* TODO when multiple row fetch available test for error on some columns */
 
-		CHK(SQLFetch, (Statement));
-		CHK(SQLFetch, (Statement));
-		if (SQLFetch(Statement) != SQL_ERROR)
-			ODBC_REPORT_ERROR("SQLFetch succeed when it shouldn't");
+		CHKFetch("S");
+		CHKFetch("S");
+		CHKFetch("E");
 	}
 
 	ReadError();
@@ -62,12 +58,11 @@ main(int argc, char *argv[])
 	SQLFetch(Statement);
 	SQLMoreResults(Statement);
 
-	CHK(SQLAllocStmt, (Connection, &stmt));
+	CHKAllocStmt(&stmt, "S");
 
 	Command(Statement, "SELECT * FROM sysobjects");
 
-	if (CommandWithResult(stmt, "SELECT * FROM sysobjects") != SQL_ERROR)
-		ODBC_REPORT_ERROR("Error expected");
+	CHKR(CommandWithResult, (stmt, "SELECT * FROM sysobjects"), "E");
 
 	tmp_stmt = Statement;
 	Statement = stmt;
diff --git a/src/odbc/unittests/freeclose.c b/src/odbc/unittests/freeclose.c
index 6998ac2..7908880 100644
--- a/src/odbc/unittests/freeclose.c
+++ b/src/odbc/unittests/freeclose.c
@@ -50,7 +50,7 @@
 
 #include "tds.h"
 
-static char software_version[] = "$Id: freeclose.c,v 1.6 2007/11/26 18:12:31 freddy77 Exp $";
+static char software_version[] = "$Id: freeclose.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /* this crazy test test that we do not send too much prepare ... */
@@ -272,7 +272,6 @@ fake_thread_proc(void * arg)
 int
 main(int argc, char **argv)
 {
-	SQLHSTMT hstmt = NULL;
 	SQLLEN sql_nts = SQL_NTS;
 	const char *query;
 	SQLINTEGER id = 0;
@@ -316,8 +315,7 @@ main(int argc, char **argv)
 	/* real test */
 	Command(Statement, "CREATE TABLE #test(i int, c varchar(40))");
 
-	if (!SQL_SUCCEEDED(SQLAllocHandle(SQL_HANDLE_STMT, Connection, &hstmt)))
-		return 1;
+	ResetStatement();
 
 	/* do not take into account connection statistics */
 	round_trips = 0;
@@ -325,30 +323,17 @@ main(int argc, char **argv)
 
 	query = "insert into #test values (?, ?)";
 
-	if (!SQL_SUCCEEDED(SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, sizeof(id), 0, &id, 0, &sql_nts))
-	    ||
-	    !SQL_SUCCEEDED(SQLBindParameter
-			   (hstmt, 2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, sizeof(string), 0, string, 0, &sql_nts))) 
-	{
-		SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-		return 1;
-	}
-
-	if (!SQL_SUCCEEDED(SQLPrepare(hstmt, (SQLCHAR *) query, SQL_NTS))) {
-		SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-		return 1;
-	}
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, sizeof(id), 0, &id, 0, &sql_nts, "SI");
+	CHKBindParameter(2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, sizeof(string), 0, string, 0, &sql_nts, "SI");
 
+	CHKPrepare((SQLCHAR *) query, SQL_NTS, "SI");
 	for (id = 0; id < num_inserts; id++) {
 		sprintf(string, "This is a test (%d)", (int) id);
-		if (!SQL_SUCCEEDED(SQLExecute(hstmt))) {
-			SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-			return 1;
-		}
-		SQLFreeStmt(hstmt, SQL_CLOSE);
+		CHKExecute("SI");
+		CHKFreeStmt(SQL_CLOSE, "S");
 	}
 
-	SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
+	ResetStatement();
 
 	Disconnect();
 
